Codeforces Round #196 (Div. 2) C--Quiz(快速幂+贪心)

C. Quiz
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Manao is taking part in a quiz. The quiz consists of n consecutive questions. A correct answer gives one point to the player. The game also has a counter of consecutive correct answers. When the player answers a question correctly, the number on this counter increases by 1. If the player answers a question incorrectly, the counter is reset, that is, the number on it reduces to 0. If after an answer the counter reaches the number k, then it is reset, and the player's score is doubled. Note that in this case, first 1 point is added to the player's score, and then the total score is doubled. At the beginning of the game, both the player's score and the counter of consecutive correct answers are set to zero.

Manao remembers that he has answered exactly m questions correctly. But he does not remember the order in which the questions came. He's trying to figure out what his minimum score may be. Help him and compute the remainder of the corresponding number after division by 1000000009 (109 + 9).

Input

The single line contains three space-separated integers nm and k (2 ≤ k ≤ n ≤ 109; 0 ≤ m ≤ n).

Output

Print a single integer — the remainder from division of Manao's minimum possible score in the quiz by 1000000009 (109 + 9).

Sample test(s)
input
5 3 2
output
3
input
5 4 2
output
6
Note

Sample 1. Manao answered 3 questions out of 5, and his score would double for each two consecutive correct answers. If Manao had answered the first, third and fifth questions, he would have scored as much as 3 points.

Sample 2. Now Manao answered 4 questions. The minimum possible score is obtained when the only wrong answer is to the question 4.

Also note that you are asked to minimize the score and not the remainder of the score modulo 1000000009. For example, if Manao could obtain either 2000000000 or 2000000020 points, the answer is 2000000000 mod 1000000009, even though2000000020 mod 1000000009 is a smaller number.






思路:思路很简单,这是一道简单的贪心体。
要使分数最低,就要使双倍的次数最少。
那么就尽可能的使k-1个放在一起而两组连续的正确题数中间插上一道错题。
易知没有双倍时,最多答对了n%k+n/k*(k+1)道题
若m小于等于上值,则分数即为m,取一下模输出;
若m大于上值,则至少有一次双倍的机会,那么越早双倍,分数越小。
即有m-{ n%k+n/k*(k+1)}次双倍,全取前面的空题
每次双倍均为分数先+k、再*2,则有k*(2^x+2^(x-1)+......+2^2+2^1)=k*(2^(x+1)-2)
这里注意可能得到负值(因为你一边模,一边求幂,可能会使得最后求出的值小于2),需加上1000000009,使得变为正。
先用快速幂求出双倍部分的分数,再加上m-x*k(之后没有双倍的部分)
最后再取下模输出
 

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <queue>
#include <cmath>
#include <stack>
#include <vector>
#include <map>
typedef long long ll;
using namespace std;
ll quickpow(ll a,ll b)
{
    ll r=1,base=a;
    while(b!=0)
    {
        if(b&1)r=(r*base)%1000000009;
        b>>=1;
        base=(base*base)%1000000009;
    }
    return r;
}
int main()
{
    ll n,m,k;
    cin>>n>>m>>k;
    ll cc=n%k+n/k*(k-1),ss;
    if(m<=cc)ss=m%1000000009;
    else
    {
        ll gg=quickpow(2,m-cc+1)-2;
        if(gg<0)gg+=1000000009;
        ss=((gg-m+cc)*k+m)%1000000009;
    }
    cout<<ss<<endl;
    return 0;
}




  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值